package Site::TableSQL;
# LICENSE
#
# Copyright (c) 2001 Steve Slaven <bpk@hoopajoo.net> All rights reserved.
#
# This program is free software  and is provided "as is" without
# express or implied warranty. You can redistribute it and/or
# modify it under the same terms as Perl itself.
#

#########  DON'T USE ME!!!!!  USE SQLTable!!!!

use PObject;
@ISA = qw( PObject );


use strict;

use HTML::Entities;
use URI::Escape;
use Carp;

use Site::FieldSQL;

$Site::TableSQL::AUTOSETTINGS = 1;
%Site::TableSQL::AUTOFIELDS = ( ACTION => $::ENV{ REQUEST_URI },
				     FORMREF => undef,
				     DATABASE => undef,
				     SQL => undef,
				     TABLE => undef,
				     PKEY => undef,
				     ORDERBY => undef,
				     SORTORDERTEXT => "(#)",
				     SORTORDERLEFT => 1,
				     SHOWSORTORDER => 1,
				     WHERE => "",
				     BORDER => 0,
				     COLOR1 => "",
				     COLOR2 => "",
				     COLOR3 => "",
				     COLOR4 => "",
				     HEADCOLOR => "",
				     WIDTH => undef,
				     ALLOWSORT => 1,
				     MINROWS => 1,
				     MAXROWS => 9999999,
				     MINERROR => "Not enough",
				     MAXERROR => "Too many",
				     NAME => 'table',
				     ONEXECGOTO => undef );

# This is the field package for the WebFormSQL package
sub OBJ_NEW
{
    my $Self = shift;

    $Self -> { ACTION } =~ s/\?.*//;
    $Self -> { BADFORM } = 0;

    $Self -> { SCREEN } = undef;
    
    # Fields are a big array
    $Self -> { FIELDS } = [];

    # Value to display
    $Self -> { displayVALUE } = undef;
    
    # Return me
    return $Self;
}

sub SetDatabase
{
	my $Self = shift;
	$Self -> Database( shift() );
}

sub SetHash
{
	my $Self = shift;
	$Self -> { FORMREF } = shift();
}

# Generates the entire HTML form, needs the hash because
# it might get re-sorted
sub display
{
	my $Self = shift;

	# The form vars are here
	my $FormRef = $Self -> { FORMREF };
	my $MyName;
	
	# Other vars used in me
	my( $ColorCounter, $Field, $Statement,
	    $RecordRef, $sth, @FieldNames );

	my( @MakeOrder, $RowCount, $AllRowRef, $CarryVars );

	my( %SortOrderDisplay, $CntNo );

	# Fix up the myname
	if( defined( $Self -> Name() ) )
	{
	    $MyName = $Self -> Name() . ".";
	}
	
	# Check if we're called by re-ordering
	if( $FormRef -> { action } eq "SORT" )
	{
	    $Self -> _dmesg( "Munging args for re-sort", 3 );
	    
	    # OK, do some hokeying around to just be a sort
	    $Self -> Where( $FormRef -> { __where } );
	    $Self -> OrderBy( $FormRef -> { __orderby } );
	    $Self -> Sql( $FormRef -> { __sql } );
	    
	    # Now take the old sort options and munge them in to
	    # something new
	    $Self -> _dmesg( "Requested sort option is: " . $FormRef -> { __sort }, 3 );
	    @MakeOrder = ( $FormRef -> { __sort } );
	    for ( split( /,/, $Self -> OrderBy() ) )
	    {
		if( $_ ne $FormRef -> { __sort } )
		{
		    $Self -> _dmesg( "Pushing " . $_ . " on order list", 3 );
		    push( @MakeOrder, $_ );
		}
	    }

	    # Only if more than one..
	    if( scalar( @MakeOrder ) > 1 )
	    {
		$Self -> _dmesg( "Using join to make order", 3 );
		$Self -> OrderBy( join( ",", @MakeOrder ) );
	    }
	    else
	    {
		$Self -> _dmesg( "Using shift to make order", 3 );
		$Self -> OrderBy( shift( @MakeOrder ) );
	    }
	}

	# Grab all field names, and while we're looping,
	# Make sure all fields are disabled
	for ( @{ $Self -> { FIELDS } } )
	{
	    if( defined( $_ -> GenerateFieldForSelectSQL() ) )
	    {
		push( @FieldNames, $_ -> GenerateFieldForSelectSQL() );
	    }

	    $_ -> SuppressAll( 1 );
	    $_ -> Disabled( 1 );
	}
 
	# OK, if no pre-gen statement then we need to make one
	if( $Self -> Sql() eq "" )
	{
	    # First prepare a statement to iterate over based on the infos
	    # This is mostly the meaty part, just no order by
	    $Statement = "select ";

	    $Statement .= join( ", ", @FieldNames );
	    $Statement .= " from " . $Self -> Table();
	    
	    if( $Self -> Where() ne "" )
	    {
		$Statement .= " where " . $Self -> Where();
	    }
	}
	else
	{
	    $Statement = $Self -> Sql();

	    # The SQL statement may not include an order by clause
	    # so that we can sort it
	    if( $Statement =~ /order\s+by/i )
	    {
		confess( "Pre-written SQL statement may not contain ORDER BY" );
	    }
	}

	if( $Self -> OrderBy() ne "" )
	{
	    $Statement .= " order by " . $Self -> OrderBy();
	}
	
	$Self -> _dmesg( "SQL statement: " . $Statement, 2 );

	# OK do something
	$sth = $Self -> Database() -> prepare( $Statement );

	if( ! $sth -> execute() )
	{
	    # Error!!
	    print "<PRE>";
	    print "An SQL error occurred while processing:\n";
	    print $Statement . "\n";
	    print $Self -> Database() -> errstr . "\n";
	    print "</PRE>";
	    return();
	}
		
	# Check enough rows...
	$AllRowRef = $sth -> fetchall_arrayref({});
	$RowCount = scalar( @{ $AllRowRef } );
	$Self -> _dmesg( "Rowcount is: " . $RowCount, 3 );
	if( $RowCount < $Self -> MinRows() )
	{
	    # Not enough rows...
	    $Self -> _Add( $Self -> MinError() );
	    return( undef );
	}

	if( $RowCount > $Self -> MaxRows() )
	{
	    # Not enough rows...
	    $Self -> _Add( $Self -> MaxError() );
	    return( undef );
	}

	# Determine the sort order and display infos
	$CntNo = 1;
	for ( split( /,/, $Self -> OrderBy() ) )
	{
	    $SortOrderDisplay{ $_ } = $Self -> SortOrderText();
	    $SortOrderDisplay{ $_ } =~ s/#/$CntNo/g;
	    $CntNo++;
	}

	$Self -> _Add(  "<TABLE BORDER=" . $Self -> Border() );
	if( defined( $Self -> Width() ) )
	{
	    $Self -> _Add( " WIDTH=" . $Self -> Width() );
	}
	$Self -> _Add( ">\n" );
	
	$Self -> _Add( "<TR" .
	    $Self -> _MakeColorTag( $Self -> HeadColor() )
		. ">\n" );

	# We need to make a string that preserves all variables,
	# But *NOT* env.* or __xad_*
	$CarryVars = join( "&", 
			   map( $_ . 
				"=" . 
				uri_escape( $FormRef -> { $_ } ),
				grep( !/^__xad_/,
				      grep( !/^env/, 
					    keys( %{ $FormRef } ) ) ) ) );

	$Self -> _dmesg( "Carry vars is: " . $CarryVars, 5 );

	# Here we'll loop through all the fields we own
	for $Field ( @{ $Self -> { FIELDS } } )
	{
	    # Ask the field to dump it's stuff
	    $Self -> _Add( "<TD>" );
	    
	    if( defined( $Field -> GenerateFieldForSelectSQL() ) )
	    {
		if( $Self -> AllowSort() )
		{
		    # Make an A tag
		    if( $Self -> ShowSortOrder() && $Self -> SortOrderLeft() )
		    {
			$Self -> _Add( $SortOrderDisplay{ $Field -> GenerateFieldForSelectSQL() } );
		    }
		    
		    $Self -> _Add( '<A HREF="' . $Self -> Action() );
		    $Self -> _Add( "?" );
		    $Self -> _Add( join( "&",
				$CarryVars,
				"ACTION=SORT",
				"__WHERE=" . uri_escape( $Self -> Where() ),
				"__SORT=" . uri_escape( $Field -> GenerateFieldForSelectSQL() ),
				"__ORDERBY=" . uri_escape( $Self -> OrderBy() ),
				"__SQL=" . uri_escape( $Self -> Sql() ) ) );
		    $Self -> _Add( '">' );
		}
		
		$Self -> _Add( $Field -> GenerateLabelHTML() );

		if( $Self -> AllowSort() )
		{
		    $Self -> _Add( "</A>" );

		    if( $Self -> ShowSortOrder() && ( ! $Self -> SortOrderLeft() ) )
		    {
			$Self -> _Add( $SortOrderDisplay{ $Field -> GenerateFieldForSelectSQL() } );
		    }
		}
	    }
	    else
	    {
		# No sorting can happen, don't even worry about the hoopa
		$Self -> _Add( $Field -> GenerateLabelHTML() );
	    }
	    
	    $Self -> _Add( "</TD>" );
	}

	# For each record....
	$ColorCounter = 1;
	for $RecordRef ( @{ $AllRowRef } )
	{
	    # start the row.  Also do some maint. on the color info
	    $Self -> _Add( "<TR" .
		$Self -> _MakeColorTag( $Self -> { "COLOR" . $ColorCounter } )
		    . ">\n" );

	    $ColorCounter++;
	    if( $ColorCounter > 4 )
	    {
		$ColorCounter = 1;
	    }

	    # Set these in the environement in case they're used by
	    # un-named fields
	    #for ( keys( %{ $RecordRef } ) )
	    #{
	    #  #XAD::Variables -> Set( $MyName . $_, $RecordRef -> { $_ } );
	    #}
	    
	    # Proc each of our fields
	    for ( @{ $Self -> { FIELDS } } )
	    {
		# Fill in the values we looked up
		if( defined( $_ -> GenerateFieldForSelectSQL() ) )
		{
		    $_ -> SetValue( $RecordRef ->
				    { $_ -> Name() } );
		}
		
		# Now dump this fields value

		$Self -> _Add( "<TD>\n" );
		$Self -> _Add( $_ -> GenerateFieldHTML( $RecordRef ) );
		$Self -> _Add( "</TD>\n" );
	    }
	    $Self -> _Add( "</TR>\n" );
	}

	# Form/table footer now
	$Self -> _Add( "</TABLE>\n" );
}


# Variable attribs
sub addfield
{
	# Pushes a new field on the end of the form.  Returns the field
	# reference to be mangled.  A particular field can be grabbed
	# using the GetFieldByIndex or GetFieldByName methods.
	my $Self = shift;

	$Self -> _dmesg( "Adding field", 3 );
	push( @{ $Self -> { FIELDS } }, Site::FieldSQL -> new( @_ ) );
	$Self -> { FIELDS } -> [ -1 ] -> SetDatabase( $Self -> { DATABASE } );
	$Self -> { FIELDS } -> [ -1 ] -> FormName( $Self -> Name() );

	return( $Self -> { FIELDS } -> [ -1 ] );
}

sub addfields
{
        my $Self = shift;
        # Takes an array of hash refs to pass to addfield
        for ( @_ )
        {
                $Self -> addfield( %{ $_ } );
        }
}

sub _MakeColorTag
{
    my $Self = shift;
    my $Color = shift;

    if( $Color ne "" )
    {
	return( " BGCOLOR=#" . $Color );
    }
    
    return( undef );
}

sub _Add
{
    my $Self = shift;
    print shift();
}

sub XAD_RUN
{
    # dispo
    my $Self = shift;
    print $Self -> { displayVALUE };
}


sub DefaultDB
{
	shift();
	$Site::TableSQL::AUTOFIELDS{ DATABASE } = shift();
}

sub DefaultFormRef
{
	shift();
	$Site::TableSQL::AUTOFIELDS{ FORMREF } = shift();
}

# Gotta return true
1;
