package Site::Template::DocTree;
# LICENSE
#
# Copyright (c) 2001 Steve Slaven <bpk@hoopajoo.net> All rights reserved.
#
# This program is free software  and is provided "as is" without
# express or implied warranty. You can redistribute it and/or
# modify it under the same terms as Perl itself.
#

use PObject;
@ISA = qw( PObject );

%Site::Template::DocTree::AUTOFIELDS = (
	PARENT => undef,
	TYPE => undef,
	DATA => undef,
	CHILDREN => undef,
	HASCHILDREN => undef );

sub OBJ_NEW
{
	my $Self = shift();

	$Self -> Children( [] );

	return( $Self );
}

sub newchild
{
	my $Self = shift;

	push( @{ $Self -> Children() }, Site::Template::DocTree -> new() );
	$Self -> Children() -> [ -1 ] -> Parent( $Self );

	$Self -> HasChildren( 1 );

	return( $Self -> Children() -> [ -1 ] );
}

sub dumptree
{
	my $Self = shift;
	my $Prefix = shift;

	print $Prefix . $Self -> Type();

	if( $Self -> Type() eq "TAG" )
	{
		print "  " . $Self -> Data() -> Tag() . "\n";
	}
	else
	{
		print "\n";
	}

	for ( @{ $Self -> Children() } )
	{
		$_ -> dumptree( $Prefix . " " );
	}

}

sub set
{
	my $Self = shift;

	$Self -> { DATA } = shift;
}

sub getparent
{
	my $Self = shift;

	if( $Self -> Parent() )
	{
		return( $Self -> Parent() );
	}
	else
	{
		$Self -> _dfatal( "Accessed null parent: " . $Self -> Data()  );
	}
}

sub add
{
	my $Self = shift;
	$Self -> { DATA } .= shift();
}

1;
