package Site::Template::Element;
# LICENSE
#
# Copyright (c) 2001 Steve Slaven <bpk@hoopajoo.net> All rights reserved.
#
# This program is free software  and is provided "as is" without
# express or implied warranty. You can redistribute it and/or
# modify it under the same terms as Perl itself.
#

use PObject();
@ISA = qw( PObject );

%Site::Template::Element::AUTOFIELDS = (
	TAG => undef,
	ATTRIBUTES => undef );

sub OBJ_NEW
{
	my $Self = shift;

	$Self -> Attributes( { escape => 'none' } );

	return( $Self );
}

sub set
{
	my $Self = shift;
	my $Attribute = shift;
	my $Value = shift;

	$Self -> Attributes() -> { lc( $Attribute ) } = $Value;
}

sub get
{
	my $Self = shift;

	return( $Self -> Attributes() -> { lc( shift() ) } );
}

sub getkeys
{
	my $Self = shift;

	return( keys( %{ $Self -> Attributes() } ) );
}

sub parse
{
	my $Self = shift;

	my $Attributes = shift;
	my( $LVal, $RVal );

        $Attributes =~ s/\s*=\s*/=/g;
        $Attributes =~ s/=(\"(.*?)\"|(\S+))/=\"$2$3"/g;
        $Attributes =~ s/(\"(.*?)\"|(\S+))=/\"$2$3\"=/g;

	$Self -> _dmesg( "Parsing: $Attributes", 3 );
	for ( split( /\"\s+\"/, $Attributes ) )
	{
		( $LVal, $RVal ) = $_ =~ /^\"?(\S*)\"=\"(.*?)\"?\s*$/;

		$Self -> _dmesg( "Split: '$LVal' and '$RVal'", 3 );
		$Self -> set( $LVal, $RVal );
	}
}

1;
